Description

Currently, the default notification option for a new user is "Only for things I watch or I'm involved in" (internal_name:

only_my_events) . This sends notifications when any of the following conditions are met.

The issue/object is watched by the user

The issue is created by the user

The issue is assigned to the user

I think the default option should now be "Only for things I watch or I am assigned to" (internal name: only_assigned) which sends

notifications when any of the following conditions are met.

The issue/object is watched by the user

The issue is assigned to the user

This is because Redmine 5.1.0 has an auto watch for newly created issues (#38238) and the option is enabled by default for newly

created users, and the behavior of the combination of auto watch and only_my_events is somewhat confusing.

Consider the following scenario:

1. Admin creates a new user. The user has all auto watches enabled by default, and the email notification option is set to

only_my_events

2. The user creates an issue. Since all auto watches are enabled for the user, they are added as a watcher

3. The user receives notifications about the issue

4. The user decides they do not want to receive notifications anymore and unwatches the issue

5. But the user still receives notifications because the notification option is only_my_events, and they are the author of the issue

If the default notification option is changed from only_my_events to only_assigned, this confusion will be eliminated. Here is a

scenario in this case:

1. Admin creates a new user. The user has all auto watches enabled by default, and the email notification option is set to

only_assigned

2. The user creates an issue. Since all auto watches are enabled for the user, they are added as a watcher

3. The user receives notifications about the issue

4. The user decides they do not want to receive notifications anymore and unwatches the issue

5. The user does not receive notifications anymore because the notification option is only_assigned, and they are no longer a

watcher

As illustrated above, in Redmine 5.1, the behavior is more understandable if the notification option defaults to only_assigned.

Related issues:

Has duplicate Redmine - Feature #38343: Change the default notification optio... Closed

Associated revisions

Revision 22503 - 2023-12-08 09:17 - Go MAEDA

Code cleanup: unnecessary use of instance variables in UserTest (#39500).

Revision 22504 - 2023-12-08 09:29 - Go MAEDA

Change the default notification option from `only_my_events` to `only_assigned` (#39500).

Patch by Go MAEDA.
Revision 22511 - 2023-12-11 10:14 - Go MAEDA

Revert r22504 that missing a necessary file (#39500).

Revision 22512 - 2023-12-11 10:20 - Go MAEDA

Change the default notification option from `only_my_events` to `only_assigned` (#39500).

Patch by Go MAEDA.

History

#1 - 2023-11-01 16:09 - Go MAEDA

- File 0001-Refactor-unnecessary-use-of-instance-variables-in-Us.patch added

- File 0002-Change-the-default-notification-option-from-only_my_.patch added

The attached patches update the default notification setting from only_my_events to only_assigned and adjust related tests accordingly.

#2 - 2023-11-12 10:37 - Go MAEDA

- Target version set to Candidate for next major release

#3 - 2023-11-13 15:45 - Go MAEDA

- File 0002-Change-the-default-notification-option-from-only_my_.patch added

Improved patch to keep the behavior when `default_notification_option` is not stored in the database in existing installations.

If `default_notification_option` is not stored in the database, `Setting.default_notification_option` returns `only_my_events` in Redmine 5.1 and earlier.

The value should not be changed in existing installations even after upgrading Redmine. See #34863#note-16.

#4 - 2023-11-14 03:37 - Go MAEDA

- File deleted (0002-Change-the-default-notification-option-from-only_my_.patch)

#5 - 2023-11-14 03:37 - Go MAEDA

- File deleted (0002-Change-the-default-notification-option-from-only_my_.patch)

#6 - 2023-11-14 03:39 - Go MAEDA

- File 0002-Change-the-default-notification-option-from-only_my_.patch added

Updated 0002-Change-the-default-notification-option-from-only_my_.patch to use Setting.find_or_create_by! in

db/migrate/20231113131245_ensure_default_notification_option_is_stored_in_db.rb.

#7 - 2023-11-27 14:01 - Go MAEDA

- Target version changed from Candidate for next major release to 6.0.0

Setting the target version to 6.0.0.

#8 - 2023-12-08 09:29 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch in r22504.

#9 - 2024-01-04 11:14 - Go MAEDA

- Has duplicate Feature #38343: Change the default notification option to "Only for things I watch or I am assigned to" added

Files

0001-Refactor-unnecessary-use-of-instance-variables-in-Us.patch 1.03 KB 2023-11-01 Go MAEDA

0002-Change-the-default-notification-option-from-only_my_.patch 3.63 KB 2023-11-14 Go MAEDA
